class RoomOccupancyTooHighException
      extends RuntimeException {}                    // (1) Unchecked Exception
class TooManyHotelsException
      extends Exception {}                           // (2) Checked Exception

class Hotel {
    // Static Members
    private static int noOfHotels = 12;
    private static Hotel[] hotelPool = createHotelPool();   // (3)

    private static Hotel[] createHotelPool() {              // (4)
        try {
             if (noOfHotels > 10)
                 throw new TooManyHotelsException();
        } catch (TooManyHotelsException e) {
             noOfHotels = 10;
             System.out.println("No. of hotels adjusted to " +
                                 noOfHotels);
        }
        return new Hotel[noOfHotels];
    }
    // Instance Members
    private int noOfRooms        = 215;
    private int occupancyPerRoom = 5;
    private int maxNoOfGuests    = initMaxGuests();         // (5)

    private int initMaxGuests() {                           // (6)
        if (occupancyPerRoom > 4)
                 throw new RoomOccupancyTooHighException();
        return noOfRooms * occupancyPerRoom;
    }
}

public class ExceptionsInInitializers {
    public static void main(String[] args) {
        try { new Hotel();}
        catch (RoomOccupancyTooHighException exception) {
             exception.printStackTrace();
        }
    }
}