class Counter extends Thread {

    private int currentValue;

    public Counter(String threadName) {
        super(threadName);                       // (1) Initialize thread
        currentValue = 0;
        System.out.println(this);
        start();                                 // (2) Start this thread
    }

    public void run() {                          // (3) Override from superclass
        try {
            while (currentValue < 5) {
                System.out.println(getName() + ": " + (currentValue++));
                Thread.sleep(500);               // (4) Current thread sleeps
            }
        } catch (InterruptedException e) {
            System.out.println(getName() + " interrupted.");
        }
        System.out.println("Exit from " + getName() + ".");
    }

    public int getValue() { return currentValue; }
}